%% SIDLOC - System Design Document
%% Copyright (C) 2021-2023 Libre Space Foundation
%%
%% This work is licensed under a
%% Creative Commons Attribution-ShareAlike 4.0 International License.
%%
%% You should have received a copy of the license along with this
%% work.  If not, see <http://creativecommons.org/licenses/by-sa/4.0/>.

\documentclass[english,title,a4paper]{report}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage[english]{babel}
\usepackage{float}
\usepackage[hidelinks]{hyperref}
\usepackage[toc,acronyms,section,nopostdot,nonumberlist,section=section,numberedsection]{glossaries}
\usepackage[toc]{appendix}
\usepackage{graphicx}
\usepackage{lastpage}
\usepackage{titlesec}
\usepackage{fancyhdr}
\usepackage{lipsum}
\usepackage{booktabs}
\usepackage[maxfloats=500]{morefloats}
\usepackage{lscape, makecell}

\fancypagestyle{plain}{
  \fancyhf{}
  \fancyhead[L]{SIDLOC}
  \fancyhead[R]{Interface Control Document}
  \fancyfoot[L]{Version \version}
  \fancyfoot[C]{\thepage{} of~\pageref{LastPage}}
  \fancyfoot[R]{\copyright{} Libre Space Foundation}
  \renewcommand{\headrulewidth}{0.4pt}
  \renewcommand{\footrulewidth}{0.4pt}
}
\pagestyle{plain}

\input{include/version}

\makeglossaries{}

%% Acronyms
\input{glossaries/acronyms}

\title{
  Interface Control Document \\
  \large{SIDLOC}
}
\author{Libre Space Foundation}
\date{\today\\Version \version\\\textit{DRAFT}}

\begin{document}

\hypersetup{pageanchor=false}
\maketitle
\hypersetup{pageanchor=true}
\tableofcontents

\chapter{Changelog}

\begin{tabular}{llp{6.5cm}}
  \toprule
  Version & Date          & Changes                            \\
  \midrule
  1.3.0   & March 8, 2023 & \textbullet{} First stable release \\
  \bottomrule
\end{tabular}

\chapter{Introduction}

\section{Purpose}
This Interface Control Document (ICD) defines the interface requirements.

\chapter{Mechanical interfaces}

\chapter{Electrical interfaces}

\section{Power supply}\label{sec:power-supply}
The power supply can accept an input voltage from 5V to 16V.
Maximum current drawn is 300mA
\section{Bus Connector}
Bus connector exposes the following interfaces:
\begin{itemize}
\item Power input
\item CAN Bus
\item UART TTL Rx
\end{itemize}

\section{Programming connector}
JTAG is used for programming all internal systems. The systems use JTAG daisy chaining and are programmed from a single connector.\newline
MCU is also accessible via SWD interface

\section{Deployment interface}

\chapter{Communication interfaces}

\section{Spacecraft interface}
There are 2 communication interfaces, CAN Bus and UART\@.
CAN Bus supports speeds up to 1Mbps and extended CAN ids. A CAN transceiver is included and conforms with CAN standards.\newline
UART supports TTL levels and only the receive line is exposed for the transfer of information from the bus to SIDLOC \newline
Deployment interface excepts a NO/NC switch signal or a Voltage signal up to 28V

\section{Programming interface}\label{req:24a}
Programming of all components is carried out via JTAG interface.
Internal subsystems are daisy-chained and accessed via a single interface.
Additionally, MCU can be programmed via SWD\@.
JTAG and SWD cannot be used at the same time.

\section{Debug interface}
Debugging of all components is carried out via JTAG interface.
Internal subsystems are daisy-chained and accessed via a single interface.
Additionally, MCU can be debugged via SWD\@.
JTAG and SWD cannot be used at the same time

\section{Configuration interface}
Configuration of all components is carried out via JTAG interface.
Internal subsystems are daisy-chained and accessed via a single interface.
Additionally, MCU can be configured via SWD\@.
JTAG and SWD cannot be used at the same time

\section{Telecommand interface}

\chapter{Software interface}

\section{Data sharing: SatNOGS DB API}
\begin{itemize}
\item SatNOGS DB API\footnote{\url{https://db.satnogs.org/api}} is a RESTful API that will share raw and produced data upon HTTP requests in JSON and CCSDS standard format
\item Kind of data:
  \begin{itemize}
  \item raw
  \item demodulated
  \item decoded
  \item orbit determination (localization)
  \item orbit identification
  \end{itemize}
\item sharing data under an open license (CC-BY-SA-v4-Int?)
\end{itemize}

\chapter{Interfaces Data Sheet}
\begin{table}[H]
  \centering
  \begin{tabular}{llll}
    \toprule
    \multicolumn{4}{c}{\textbf{Power}}                                                                                      \\ \midrule
    \multicolumn{1}{l}{}                       & \multicolumn{1}{l}{\textbf{Min}} & \multicolumn{1}{l}{\textbf{Max}} & \textbf{Unit}  \\ \midrule
    \multicolumn{1}{l}{\textbf{Input voltage}} & \multicolumn{1}{l}{5}            & \multicolumn{1}{l}{16}           & V  \\ \midrule
    \multicolumn{1}{l}{\textbf{Input current}} & \multicolumn{1}{l}{-}            & \multicolumn{1}{l}{300}          & mA \\ \midrule
  \end{tabular}
\end{table}

\begin{table}[H]
  \centering
  \begin{tabular}{lll}
    \toprule
    \multicolumn{3}{c}{\textbf{JTAG/SWD}} \\ \midrule

    \textbf{Pin} & \textbf{JTAG}             & \textbf{SWD} \\ \midrule
    1            & CLK                       & CLK          \\ \midrule
    2            & JTDI &              \\ \midrule
    3            & JTDO & SWO          \\ \midrule
    4            & JRST                      &              \\ \midrule
    5            & JTMS                      & SWDIO        \\ \midrule
    6            & GND                       & GND          \\ \midrule
  \end{tabular}
\end{table}

\begin{appendices}

  \chapter{Glossary and Acronyms}
  \printglossary[type=\acronymtype]

\end{appendices}

\end{document}
